-- Broken Bottle - 7DRL
-- Copyright (C) 2011 Darren Grey
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.


return {
	name = "Upper Mines",
	level_range = {4, 10},
	max_level = 3,
	decay = {300, 800},
	width = 50, height = 50,
	persistent = "zone",
	generator =  {
		map = {
			class = "engine.generator.map.Roomer",
			nb_rooms = 10,
			rooms = {"simple", "pilar"},
			['.'] = "FLOOR",
			['#'] = "WALL",
			up = "UP",
			down = "DOWN",
			door = "DOOR",
		},
		actor = {
			class = "engine.generator.actor.Random",
			nb_npc = {20, 30},
		},
      object = {
         class = "engine.generator.object.Random",
         nb_object = {3, 6},
      },
	},
		levels =
	{
		[1] = {
			generator = { map = {
				up = "DOWN_CAVES",
			}, },
         
		},
		[3] = {
			generator =  { map = {
            force_last_stair = true,
				down = "UP_TUNNEL",
            }, 
         actor = {
			class = "engine.generator.actor.Random",
         guardian = "BANDIT_LEADER",
            },
         },
		},
	},
   
  
   on_enter = function(lev, old_lev, newzone)
      if lev == 1 then
         local Dialog = require("engine.ui.Dialog")
         if not game.level.shown_warning then
            Dialog:simpleLongPopup("Upper Mines", "The military ain't been past here in years.  Everyone they send up don't come back.  That's why they send losers like me up instead.\n\nI wonder what's happened to all the fellas that have been sent up here before.  Do they get killed off by bandits and muggers?  Is there some unheard of horrible death lurking ahead in wait...?\n\nOr do they find their way out to freedom?  Is there some glorious hope before me?  Hah, some chance...\n",500)
            game.level.shown_warning = true
         end
      end
      if lev == 3 then
         local Dialog = require("engine.ui.Dialog")
         if not game.level.shown_warning then
            Dialog:simpleLongPopup("Upper Mines", "The air here feels a little different - less musty I guess.  I wonder... naw, can't be...\n\nThe walls around are scrawled in graffiti, the logo of some bandit clan perhaps.  I was in a bandit gang once.  Did a lot of terrible terrible things.  Not even the drink can wash all those dark memories away...\n\nI hear a noise ahead, like a buzzing sound - something mechanical.  Shit, I don't even wanna think what that could be.\n",500)
            game.level.shown_warning = true
         end
      end
   end,
   
}
